Subject: [bug#68677] [PATCH 0/6] Service for "virtual build machines"

From: Simon Tournier <[email-masked]>
Date: Thu, 25 Jan 2024 15:18:34 +0100

Hi Ludo,

On mar., 23 janv. 2024 at 17:46, Ludovic Courtès <[email-masked]> wrote:

> Lots of talk about reproducibility and how wonderful Guix is, but
> as soon as you try to build packages from v1.0.0, released less
> than 5 years ago, you hit a “time trap” in Python, in OpenSSL, or
> some other ugly build failure—assuming you managed to fetch source
> code in the first place¹.

Cool!  Workarounds for “time trap” of the current past.

Note that today is the past of the future. ;-) Other said, the same
workarounds will help to detect today thus fix the “time trap” that
would arise in the future.

Without mentioning the bug of 2038 year. :-)

> This patch series defines a long-overdue
> ‘virtual-build-machine-service-type’: a service to run a virtual
> machine available for offloading.  My main goal here is to
> allow users to build stuff at a past date without having to
> change their system clock.  It can also be used to control other
> aspects usually not under control: the CPU model, the Linux kernel.

Yes, controlling CPU model and Linux kernel are worth:

 + CPU model because we already have examples of failures (Python 3.7
   packaged in Guix v1.0.0, some BLAS libraries, etc.);

 + Linux kernel because its stability is one of the strong assumption we
   are making for reproducibility.

Cheers,
simon